using Indotalent.Data.Entities;
using Indotalent.Shared.Consts;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Metadata.Builders;

namespace Indotalent.Infrastructure.Database.MsSQL.Configuration;

public class VendorContactConfiguration : IEntityTypeConfiguration<VendorContact>
{
    public void Configure(EntityTypeBuilder<VendorContact> builder)
    {
        builder.Property(e => e.Name)
            .HasMaxLength(GlobalConsts.StringLengthShort);

        builder.Property(e => e.AutoNumber)
            .HasMaxLength(GlobalConsts.StringLengthShort);

        builder.Property(e => e.JobTitle)
            .HasMaxLength(GlobalConsts.StringLengthShort);

        builder.Property(e => e.PhoneNumber)
            .HasMaxLength(GlobalConsts.StringLengthShort);

        builder.Property(e => e.EmailAddress)
            .HasMaxLength(GlobalConsts.StringLengthShort);

        builder.Property(e => e.Description)
            .HasMaxLength(GlobalConsts.StringLengthMedium);

        builder.Property(e => e.VendorId)
            .HasMaxLength(GlobalConsts.StringLengthId);

        builder.HasOne(e => e.Vendor)
            .WithMany(e => e.VendorContactList)
            .HasForeignKey(e => e.VendorId)
            .OnDelete(DeleteBehavior.Cascade);

        builder.HasIndex(e => e.Name);
        builder.HasIndex(e => e.AutoNumber).IsUnique();
        builder.HasIndex(e => e.VendorId);
    }
}